# coding: utf-8

"""
    RIME Rest API

    API methods for RIME. Must be authenticated with `rime-api-key` header.  # noqa: E501

    OpenAPI spec version: 1.0
    Contact: dev@robustintelligence.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RcaRCAResult(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'feature_causes': 'list[RcaFeatureCause]',
        'description': 'str',
        'description_html': 'str'
    }

    attribute_map = {
        'feature_causes': 'featureCauses',
        'description': 'description',
        'description_html': 'descriptionHtml'
    }

    def __init__(self, feature_causes=None, description=None, description_html=None):  # noqa: E501
        """RcaRCAResult - a model defined in Swagger"""  # noqa: E501
        self._feature_causes = None
        self._description = None
        self._description_html = None
        self.discriminator = None
        if feature_causes is not None:
            self.feature_causes = feature_causes
        if description is not None:
            self.description = description
        if description_html is not None:
            self.description_html = description_html

    @property
    def feature_causes(self):
        """Gets the feature_causes of this RcaRCAResult.  # noqa: E501

        Potentially problematic features that may have caused the MetricDegradationEvent. Sorted by confidence score.  # noqa: E501

        :return: The feature_causes of this RcaRCAResult.  # noqa: E501
        :rtype: list[RcaFeatureCause]
        """
        return self._feature_causes

    @feature_causes.setter
    def feature_causes(self, feature_causes):
        """Sets the feature_causes of this RcaRCAResult.

        Potentially problematic features that may have caused the MetricDegradationEvent. Sorted by confidence score.  # noqa: E501

        :param feature_causes: The feature_causes of this RcaRCAResult.  # noqa: E501
        :type: list[RcaFeatureCause]
        """

        self._feature_causes = feature_causes

    @property
    def description(self):
        """Gets the description of this RcaRCAResult.  # noqa: E501


        :return: The description of this RcaRCAResult.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this RcaRCAResult.


        :param description: The description of this RcaRCAResult.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def description_html(self):
        """Gets the description_html of this RcaRCAResult.  # noqa: E501


        :return: The description_html of this RcaRCAResult.  # noqa: E501
        :rtype: str
        """
        return self._description_html

    @description_html.setter
    def description_html(self, description_html):
        """Sets the description_html of this RcaRCAResult.


        :param description_html: The description_html of this RcaRCAResult.  # noqa: E501
        :type: str
        """

        self._description_html = description_html

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RcaRCAResult, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RcaRCAResult):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
